#include "mex_io.h"
#include "debug/except.h"


template<typename type> mxClassID mexClassId(){
	throw debug_exception(String("Type is not recognized: ")+typeid(type).name());
};

template<> mxClassID mexClassId<char>(){
	return mxINT8_CLASS;
};

template<> mxClassID mexClassId<unsigned char>(){
	return mxUINT8_CLASS;
};

template<> mxClassID mexClassId<short>(){
	return mxINT16_CLASS;
};

template<> mxClassID mexClassId<unsigned short>(){
	return mxUINT16_CLASS;
};

template<> mxClassID mexClassId<int>(){
	return mxINT32_CLASS;
};

template<> mxClassID mexClassId<unsigned int>(){
	return mxUINT32_CLASS;
};

template<> mxClassID mexClassId<long long>(){
	return mxINT64_CLASS;
};

template<> mxClassID mexClassId<unsigned long long>(){
	return mxUINT64_CLASS;
};

template<> mxClassID mexClassId<float>(){
	return mxSINGLE_CLASS;
};

template<> mxClassID mexClassId<double>(){
	return mxDOUBLE_CLASS;
};

template<> mxClassID mexClassId<bool>(){
	return mxLOGICAL_CLASS;
};

template<> mxClassID mexClassId<char*>(){
	return mxCHAR_CLASS;
};

Engine *matlab = 0;

void start_engine(){
	std::cout << "Starting MATLAB engine" << std::endl;
	#ifdef WIN32
        matlab = engOpen(NULL);
	#else
        matlab = engOpen("matlab -nosplash");
	#endif
	if (!matlab){
		debug_exception("Cant start matlab Engine");
	};
	#ifdef WIN32
        engSetVisible(matlab, true);
	#else
        //engEvalString(matlab, "pmode start 1");
	#endif
};

void eng_put(const char * name, mxArray * A){
    engPutVariable(matlab,name,A);
    #ifndef WIN32
    engEvalString(matlab,(std::string("pmode client2lab")+name+" 1;").c_str());
    #endif
};

void eng_get(const char * name, mxArray * A){

};

void eng_run(const char * script){

};
