#include "openni_view.h"

//#include <QtCore/QBasicTimer>
#include <QtGui/QPainter>
//#include <QtGui/QDialog>

#include <sstream>

QView::QView():label(0),count(0) {
};

QView::~QView(){
    if(label){
        delete info;
        delete label;
    };
};

void QView::init(int Width, int Height) {
    if(!label) {
        img = QImage(Width, Height, QImage::Format_RGB32);
        img.fill(QColor(0,0,0));
        label = new QLabel();
        label->setScaledContents(true);
        label->resize(Width*2,Height*2);
        label->show();
        info = new QLabel(label);
        info->setText("Info");
        info->move(10,10);
        info->show();
    };
};

void QView::show(const openni_cam::openni_cam & cam) {
    //++count;
    int Width = cam.rgb_width();
    int Height = cam.rgb_height();
    if(!label)init(Width,Height);
// display image
    QRgb * pimg = (QRgb*)img.bits();
    unsigned char * prgb = cam.rgb.begin();
    double max_depth = -1e5;
    double min_depth = 1e5;
    for(int i = 0; i < (Width) * (Height); ++i) {
        if(cam.depth[i]>0) {
            double v = 1/(double(cam.depth[i]));
            if(v>max_depth)max_depth = v;
            if(v<min_depth)min_depth = v;
        };
    };
    for(int i = 0; i < (Width) * (Height); ++i) {
        unsigned char * pixel = &prgb[i*3];
        double V = 1.0;
        if(cam.depth[i]>0) {
            double v = 1/(double(cam.depth[i]));
            V = (v-min_depth)/(max_depth-min_depth);
            pimg[i] = qRgb(floor((V)*255),floor((V)*255),0);
            //pimg[i] = qRgb(std::max(std::min(int(floor((0.5-0.5*V)*255+(0.5*V+0.5)*pixel[0])),255),0),std::max(std::min(int(floor((0.5-0.5*V)*255+(0.5*V+0.5)*pixel[1])),255),0),floor(V*pixel[2]));
            //pimg[i] = qRgb(std::max(std::min(int(floor((1-V)*255)),255),0),std::max(std::min(int(floor((1-V)*255)),255),0),0);
        } else {
            pimg[i] = qRgb(pixel[0],pixel[1],pixel[2]);
        };
       //pimg[i] = qRgb(std::max(std::min(int(floor((1-V)*255)),255),0),std::max(std::min(int(floor((1-V)*255)),255),0),pixel[2]);
    };
    label->setPixmap(QPixmap::fromImage(img));
    {
        std::stringstream ss;
        ss<<count;
        info->setText(QString("<font color='black' size='6'>")+ss.str().c_str()+QString("</font>"));
        info->adjustSize();
    };
    ///
};
