#ifndef IMAGERHARDWARE_H
#define IMAGERHARDWARE_H

#pragma once

#define TempTECMin 0.0
#define TempTECMax 80.0

#define CHECKHW(_HardwareRev_, _Compare_) (_HardwareRev_ >= _Compare_)
#define CHECKFW(_FirmwareRev_, _Compare_) (_FirmwareRev_ >= _Compare_)
#define CHECKHWFW(_HWRev_, _CompHW_, _FWRev_, _CompFW_) (CHECKHW(_HWRev_, _CompHW_) && CHECKFW(_FWRev_, _CompFW_))

// definitions of HW revision numbers that allows functionality or not

// stablization time for the thermo electric cooler could be reduced from 30 to 15 seconds with HW revision 5:
#define HW_TEC15sec 5

// -------------------------- Hardware revison of the PI 2 -----------------------------------------
#define HW_PI2 20
#define CHECK_PI2(_HardwareRev_) (CHECKHW(_HardwareRev_, HW_PI2))

// different video modi available:
#define HW_VisibleCam HW_PI2
// internal temperature format of the intern sensors was changed from 1/10 to 1/100:
#define HW_TempFormatChanged HW_PI2
// chip temperature calibration was changed
#define HW_ChipTempRefChanged HW_PI2+1

#define HW_FlexChipTemp HW_PI2


// -------------------------- Hardware revison of the PI 2 -----------------------------------------
#define FW_PI2 2000
// supporting the setting of FID and Skim with waiting on the next flag cycle
#define FW_AutoSkim 2011

#endif // IMAGERHARDWARE_H
