#pragma once
#include "OpBase.h"
#include "MyDefs.h"
#include <limits.h>
#include <sys/time.h>

class OpFrameReduce : public OpBase
{
public:
        OpFrameReduce(OpBase *prevOp, IPOperation op, wchar_t *name, PGlobalVars global);
	~OpFrameReduce(void);
protected:
        long Init(POpBase prevOp);
        long Processing(void);
    long ProcessFrame(bool DoDownstream);
        long ProcessFrame16_Send(void);
        long ProcessFrame16_Store(void);
        long ProcessFrame32_Send(void);
        long ProcessFrame32_Store(void);
	void SetFrameInterval(void);

    bool m_bFirstFrame;
	int *aiFrame;
	bool *abInvalidPixel;
	WORD  wFrameCount;
	REFERENCE_TIME AvgExt_Time;
	REFERENCE_TIME NextFrameTime;		// frame time that must be reached to send the next frame downstream
	REFERENCE_TIME LastStartTimeCorr;	// start time of last frame, based on the drift corrected value
	DWORD TT;
	bool m_InvalidPixelFound;
	bool rec;
        long lTime, l1Time, lTime_;

    TReduceMode m_ReduceMode;   // the reducing mode
    TReduceMode m_ReduceModeLast;  // Last flag state
	REFERENCE_TIME	m_FrameInterval_AvgExt;
	REFERENCE_TIME	m_TimeWeSkip;
	DWORD		m_FrameCountIn, m_FrameCountOut;
	REFERENCE_TIME	FrameIntervalIn, FrameIntervalOut;

// --- Interface functions ----------------------------------------------------
public:
    long GetReduceMode(TReduceMode *pVal);
    long SetReduceMode(TReduceMode Val);
    long SetFramerate(double Val);
        long GetTimeWeSkip(DWORD *pTimeMs);
    long GetFrameCount(DWORD *pFrameCountIn, DWORD *pFrameCountOut);
    long GetFrameIntervalAvgExt(DWORD *pVal);
    long SetFrameIntervalAvgExt(DWORD Val);
};
