#pragma once
#include "OpBase.h"

class OpMetadata : public OpBase
{
public:
        OpMetadata(OpBase *prevOp, IPOperation op, wchar_t *name, PGlobalVars global);
	~OpMetadata(void);

protected:
        long Init(POpBase prevOp);
        long Processing(void);
	void CheckPIF(void);

	float m_SetTempFlag;
	float m_SetTempBox;
	float m_SetTempChip;
	WORD m_SetPifIn;
	bool m_SetPifInDig;
	DWORD m_SetCounter;

	float m_TempFlag;
	float m_TempBox;
	float m_TempChip;
	WORD m_PifIn;
	bool m_PifInDig;
	DWORD m_Counter;

	bool TriggerSnapshot, TriggerRecording, TriggerLinescanner;
	fpOnPIF m_fpOnPIFIn, m_fpOnPIFInDig;

// --- Interface functions ----------------------------------------------------
public:
        long GetTempFlag(float *pVal)		{ return GetFloat(pVal, &m_TempFlag); }
        long GetTempBox(float *pVal)		{ return GetFloat(pVal, &m_TempBox); }
        long GetTempChip(float *pVal)		{ return GetFloat(pVal, &m_TempChip); }
        long GetPifIn(WORD *pVal)               { return GetWORD(pVal, &m_PifIn); }
        long GetPifInDig(bool *pVal)		{ return GetBool(pVal, &m_PifInDig); }
        long GetFrameCounter(DWORD *pVal)	{ return GetDWORD(pVal, &m_Counter); }

        long SetCallback_OnPIFIn(fpOnPIF OnPIFIn);
        long SetCallback_OnPIFInDig(fpOnPIF OnPIFInDig);
};
