#pragma once

#ifdef WIN32
#include <windows.h>
#endif
#include "../ImagerTypes.h"
#include "../ImagerDefs.h"

//#define ALL_CL2C

enum IPOperation 
{ 
	opDevice,		// from PI
	opSrcIR,		// Source operation for IR data
	opMD,			// fill and readmetadata (TChip, TFlag, TBox ...)
	opFlag,			// after flag operation
	opFreeze,		// freeze image (if flag closed)
	opFR,		// frame reducing IR
	opNone
};

enum IPDeviceType {	devIR, devVisible };
enum IPFormatParseType { ParseByGUID, ParseByFormat };


#define OPCOUNT opNone

typedef long long REFERENCE_TIME;

class BufferConfig
{
public:
	BufferConfig(void);
	BufferConfig(BufferConfig *config);
	BufferConfig(FrameConfig *Config);

	FrameConfig GetFrameConfig(void);
	int Width;
	int Height;
	int Size;
	int ImageSize;
	REFERENCE_TIME AvgTimePerFrame;
	unsigned short BitCount;
	IPDataType DataType;
};

class ProcessingBuffer
{
public:
	ProcessingBuffer(void);

	BufferConfig *config;
	FrameMetadata *metadata;
	void *data;
};

struct GlobalVars
{
	WORD ImgIndex;
        unsigned short HWRev;
        unsigned short FWRev;
	bool IsCali;
	int SerialNumber;
	int FOV;
	float TempRangeMin, TempRangeMax;
	float EnergyRangeMin, EnergyRangeMax;
        wchar_t* ConfigDirectory;
        wchar_t* CaliDirectory;
        wchar_t* ApplDirectory;
        wchar_t* MissingCaliFilename;
	TFlagState	FlagState;      // Flag state
	bool DoSnapshot;
	void* HID;
	short Skim_Adjust;
	bool HasVisibleStream;
	bool IsLive;
	bool IsRecording;
	RecordingDetails RecDetails;
	fpOnError OnError;
	PIFConfigStruct PifConfig;
};

typedef BufferConfig * PBufferConfig;
typedef ProcessingBuffer * PProcessingBuffer;

typedef PBufferConfig * PPBufferConfig;
typedef PProcessingBuffer * PPProcessingBuffer;

typedef GlobalVars * PGlobalVars;
