#ifndef HIDCOMM_H
#define HIDCOMM_H

#include <string.h>
#include <fcntl.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <libudev.h>
#include <stdlib.h>
#include <wchar.h>
#include "hidapi.h"
#include "../../MyDefs.h"

struct DEVICE_DESCRIPTION{
    unsigned int      pid;
    unsigned int      vid;
    wchar_t           manufacturer[256];
    wchar_t           product[256];
    unsigned int      version;
    unsigned long     serial_number;
    unsigned int      count;
};

struct HID_CAPS{
    unsigned short    InputReportByteLength;
    unsigned short    OutputReportByteLength;
};

class HIDComm
{

    unsigned char       InputReport[256];
    hid_device          *handle;
    bool                MyDeviceDetected;
    bool                MyDeviceOpened;
    char                *MyDevicePathName;
    unsigned short      DeviceHardwareRev;
    HID_CAPS            Capabilities;
    int			LogLevel;
    FILE                *fstream;

public:

    HIDComm();
    ~HIDComm();
    int get_device_info(DEVICE_DESCRIPTION *ptr_devinf);
    bool open_device(DEVICE_DESCRIPTION *ptr_devinf);
    unsigned int close_device(void);
    int OpenLog(int Loglevel,  wchar_t* Filename);
    void sleep_ms(unsigned int mseconds);
    int get_send_buffer_len();
    int get_receive_buffer_len();
    int command(unsigned char *out_array, unsigned short len, bool with_answer, unsigned char **answer);
    unsigned int get_hardware_rev(void);

private:
    int read_from_device();
    int write_to_device(unsigned char * OutputReport);


};

#endif // HIDCOMM_H
