#include "ImagerDefs.h"
#include "ImagerTypes.h"
#include "EasyImagerDLL_global.h"
#pragma once
// ImageProcessing.h
// Encasultes the Image-Processing-Class for Windowsplattforms

#ifdef __cplusplus 
extern "C"
{
#endif

#define IP_API EASYIMAGERDLLSHARED_EXPORT HRESULT

IP_API CreateImagers(WORD Count);
IP_API ReleaseImagers(void);
IP_API ConfigHID(WORD ImgIndex, DWORD VidImager, DWORD PidImager, unsigned long Sernr, WORD *HWRev, WORD *FWRev, ULONG *PifSerial, bool *LimitFramerate);
IP_API ConfigImageProcessing(WORD ImgIndex, ImgProcConfig *imgProcConfig, FrameConfig *frameConfig, void **buffer);
IP_API ConfigImageProcessingEx(WORD ImgIndex, ImgProcConfig *imgProcConfig, FrameConfig *frameConfig, void **buffer, int imgProcSettings);
IP_API InitImageProcessing(WORD ImgIndex);
IP_API SetHIDLog(WORD ImgIndex, int Loglevel, WCHAR *Filename);
IP_API NewFrame(WORD ImgIndex, PNewFrameBuffer Buffer);
IP_API RepeatFrame(WORD ImgIndex);
IP_API GetConfig(WORD ImgIndex, IPDataType datatype, PFrameConfig config);
IP_API GetCurrentBuffer(WORD ImgIndex, IPDataType datatype, long bufferSize, PVOID buffer);

IP_API SetCallback_OnPIFIn(WORD ImgIndex, fpOnPIF OnPIFIn);
IP_API SetCallback_OnPIFInDig(WORD ImgIndex, fpOnPIF OnPIFInDig);
IP_API GetCaliOpticsCount(WORD ImgIndex, int *pOpticsCount);
IP_API GetCaliOpticsIndex(WORD ImgIndex, int FOV, int *pOpticsIndex);
IP_API GetCaliOpticsFOV(WORD ImgIndex, int Index, int *pFOV);
IP_API GetCaliTempRangeCount(WORD ImgIndex, int FOV, int *pTempRangeCount);
IP_API GetCaliTempRangeIndex(WORD ImgIndex, int FOV, float TempRangeMin, float TempRangeMax, int *pTempRangeIndex);
IP_API GetCaliTempRangeMin(WORD ImgIndex, int FOV, int Index, float *pTempRangeMin);
IP_API GetCaliTempRangeMax(WORD ImgIndex, int FOV, int Index, float *pTempRangeMax);
IP_API SetOpticsAndTemprange(WORD ImgIndex, int FOV, float TempRangeMin, float TempRangeMax);
IP_API SetFlag(WORD ImgIndex, TFlagState Val);
IP_API StartFlag(WORD ImgIndex);
IP_API SetPifOut(WORD ImgIndex, WORD Voltage);
IP_API ConfigPIF(WORD ImgIndex, PIFConfigStruct *pConfig);
IP_API GetMissingCaliFilename(WORD ImgIndex, WCHAR *pFilename, int Len);
IP_API GetDLLVersion(WORD ImgIndex, long long *pVal);

// Operation: Source
IP_API GetVideoConfig(WORD ImgIndex, PVideoConfig pVC_in, PVideoConfig pVC_out, int Channels, int *pRead);
IP_API GetResolutionIR(WORD ImgIndex, SIZE *pVal);
IP_API GetFramerateIR(WORD ImgIndex, double *pVal);

// Operation: Fill Metadata
IP_API GetTempFlag(WORD ImgIndex, float *pVal);
IP_API GetTempBox(WORD ImgIndex, float *pVal);
IP_API GetTempChip(WORD ImgIndex, float *pVal);
IP_API GetPifIn(WORD ImgIndex, WORD *pVal);
IP_API GetPifInDig(WORD ImgIndex, bool *pVal);
IP_API GetFrameCounter(WORD ImgIndex, DWORD *pVal);

// Operation: Flag
IP_API GetFlag(WORD ImgIndex, TFlagState *pFlag);
IP_API ResetFlag(WORD ImgIndex);
IP_API StartFlag(WORD ImgIndex);
IP_API SetCallback_OnFlagState(WORD ImgIndex, fpOnFlagState OnFlagState);

IP_API SetFreezeImage(WORD ImgIndex, bool Val);

// Operation: Frame reducing
IP_API GetReduceMode(WORD ImgIndex, TReduceMode *pVal);
IP_API SetReduceMode(WORD ImgIndex, TReduceMode Val);
IP_API GetFramerate(WORD ImgIndex, double *pVal);
IP_API SetFramerate(WORD ImgIndex, double Val);
IP_API GetTimeWeSkip(WORD ImgIndex, DWORD *pTimeMs);
IP_API GetFrameCount(WORD ImgIndex, DWORD *pFrameCountIn, DWORD *pFrameCountOut);
IP_API GetFrameIntervalAvgExt(WORD ImgIndex, DWORD *pVal);
IP_API SetFrameIntervalAvgExt(WORD ImgIndex, DWORD Val);

// Operation: Mux and Demux
IP_API GetRecordingDetails(WORD ImgIndex, RecordingDetails *pRecDetails);
IP_API SetRecordingDetails(WORD ImgIndex, RecordingDetails *pRecDetails);

#ifdef __cplusplus 
}
#endif
