#pragma once
#ifndef NULL
#define NULL 0
#endif

#ifndef MAX_PATH
#define MAX_PATH 260
#endif

#ifndef HRESULT
#define HRESULT long
#endif

#ifndef STDMETHODIMP
#define STDMETHODIMP long
#endif

#ifndef S_OK
#define S_OK 0
#endif

#ifndef S_FALSE
#define S_FALSE -1
#endif

#ifndef BYTE
#define BYTE unsigned char
#endif

#ifndef WCHAR
#define WCHAR wchar_t
#endif

#ifndef WORD
#define WORD unsigned short
#endif

#ifndef DWORD
#define DWORD unsigned long
#endif

#ifndef SWAP_WORD
#define SWAP_WORD(w) ((w>>8) | (w<<8))
#endif

#ifndef SWAP_DWORD
#define SWAP_DWORD(dw) ((dw>>24) | ((dw<<8) & 0x00FF0000) | ((dw>>8) & 0x0000FF00) | (dw<<24))
#endif

#define LIMITS(x, lo, hi) (max(min(x, hi), lo))

#define LOBYTE(w)  ((BYTE)((unsigned long)(w) & 0xff))
#define HIBYTE(w)  ((BYTE)((unsigned long)(w) >> 8))

#define INTERNAL2CELSIUS(_X_) (0.1f * ((_X_) - 1000.0f))
#define CELSIUS2INTERNAL(_X_) (10.0f * (_X_) + 1000.5f)
#define FROMINT(_X_) (float(INTERNAL2CELSIUS(_X_)))
#define TOINT(_X_) (unsigned short(CELSIUS2INTERNAL(_X_)))

#define FROM100(_X_) (float(0.01f * (_X_)))
#define TO100(_X_) (short(100.0f * (_X_) + (((_X_)>=0)?0.5:-0.5)))

typedef WCHAR *PWCHAR;


