#ifndef KOMMANDO_H
#define KOMMANDO_H

#define EEPROM_PAGE_SIZE 	64
#define EP0_BUFSIZE		0x40

//I2C-Adressen fr die jeweiligen Bausteine
#define MSP_ADDR			0x4D
#define I2C_IOEXP_ADRESS		0x38
#define I2C_IOEXPFRONT_ADRESS           0x39
#define I2C_IOEXP_TASTATUR		0x20
#define I2C_TMP1_ADRESS			0x48
#define I2C_DAC_ADRESS			0x4C
#define I2C_EEPROM_ADRESS_CODE          0x51
#define I2C_EEPROM_ADRESS_HKD           0x57
#define I2C_SWITCH			0x70


//Welche befehlsstruktur
#define ANYTEST				0x01
#define ERRCODE				0x02
#define	CYP				0x34
#define MSP				0x4D

//Befehle fr I2C-Bausteine
#define MSP_WRWORD			0x11
#define MSP_DEVOUT			0x13
#define MSP_DEVIN			0x14
#define PW_CONTROL			0x40
#define RD_LARGEEPROM			0x50
#define WR_LARGEEPROM			0x51
#define	FLAG_DIRECTION			0x55
//#define Motor_Stop			0x04
#define I2C_IOEXP_READ			0x56
#define I2C_IOEXP_SETBIT		0x57
#define I2C_DAC_SET			0x58
#define I2C_TEMP_BOX_FRONT		0x59
#define I2C_TEMP1_INT			0x5A
#define I2C_IOEXPFRONT_READ		0x5B
#define I2C_IOEXPFRONT_SETBIT           0x5C
#define I2C_DACTEC_SET			0x5D
#define I2C_DACPIF_SET			0x5E
#define SET_TEC_CTL			0x5F
#define I2C_ADCPIF_GET			0x60
#define I2C_TEMP_FLAG_GET		0x61
#define GET_INTERLEAVE			0x62
#define GET_ALL_TEMP			0x63
#define GET_FLAG                        0x64
#define FLAG_CYCLE			0x65
#define I2C_TEMP_HOUSE_GET		0x66
#define FWCYPVERS_GET			0x67
#define FWMSPVERS_GET			0x68
#define PIF_OUT_MODE			0x69
#define PIF_OUT_FLAGOPEN		0x6A
#define PIF_OUT_FLAGCLOSED		0x6B
#define PIF_OUT_FLAGMOVING		0x6C
#define PIF_IN_MODE			0x6D
#define PIF_IN_FLAGOPENIFLOWER          0x6E
#define PIF_IN_FLAG_THRESHOLD           0x6F
#define PIF_IN_DIGITAL_MODE		0x70
#define PIF_IN_DIGITAL_FLAG_LOWACTIVE	0x71
#define PIF_READ_EEPROM			0x72

//Unterscheidung der DACs
#define	TECA				0x10
#define	TECB				0x12
#define	TECC				0x14
#define	TECD				0x16

#define	TEC				0x10
#define SKIM				0x12
#define FID				0x14

#define SKIMFLEX			0x10
#define FIDFLEX				0x12
#define WAITFORFLAG			0x80

#define MSP_PIOUT			0x00
#define MSP_SKIM			0x02
#define	MSP_FID				0x03
#define MSP_ENABLE_BIAS			0x04
#define MSP_DISABLE_BIAS		0x05

#define FLAG_OPEN			0x00
#define FLAG_CLOSE			0x01

//Position der Daten im Datenstrom

#define DATALENGTH			64

#define MSP_TEMP			0
#define FLAG_TEMP			4
#define I2C_EXP_FRONT			6
#define FLAG_BOX_FRONT			7
#define GETPIF				9
#define FLAGSTATE			11
#define USB_SPEED			12
#define HOUSE_TEMP			13
#define FWCYPVERS			15
#define FWMSPVERS			17
#define HANDLING			19

#endif
