#include "camera.h"

#include <libudev.h>
#include <stdio.h>
#include <stdlib.h>
#include <locale.h>
#include <unistd.h>
#include <string.h>

#include <sys/mman.h>
#include <fcntl.h>              /* low-level i/o */
#include <sys/ioctl.h>
#include <asm/types.h>          /* for videodev2.h */
#include <linux/videodev2.h>

#include <sstream>
#include <iostream>
#include "error.h"

#include <errno.h>

#define CLEAR(x) memset (&(x), 0, sizeof (x))


void camera::init() {
    find_device();
    init_device();
};

void camera::enque_buff(int i) {
    int r;
    buf.index = i;
    //buf.m.userptr = (unsigned long)buffers[i].start;
    //buf.length = buffers[i].length;
    r = ioctl(fd,VIDIOC_QBUF,&buf);
    if(r<0)perror("VIDIOC_QBUF");
};

void camera::deque_buff() {
    int r;
    r = ioctl(fd, VIDIOC_DQBUF, &buf);
    if(r<0)perror("VIDIOC_DQBUF:");

    int i=0;
    for (; i < n_buffers; ++i)if ((void*)buf.m.userptr == buffers[i].start)break;
    if(i >= n_buffers) {
        pperror("WTF is just happened?\n");
        exit(0);
    };
    current = i;
    buffer = buffers[current];

};

bool camera::get_image() {
    int r;
    /*
    fd_set fds;
    struct timeval tv;
    FD_ZERO (&fds);
    FD_SET (fd, &fds);
    tv.tv_sec = 2; tv.tv_usec = 0; // Timeout.
    r = select (fd + 1, &fds, NULL, NULL, &tv);
    if(r<0){
        perror("select:");fflush(stdout);
        r = ioctl(fd,VIDIOC_STREAMOFF,&buf.type);
        start_device();
        return;
    };
    */
    //usleep(100);
    //enque_buff(current);
    for(int i=0; i<n_buffers; ++i) {
        if(!buffers[i].queued) {
            buf.index = i;
            r = ioctl(fd,VIDIOC_QBUF,&buf);
            if(r<0){
                perror("VIDIOC_QBUF");
                exit(1);
            };
            buffers[i].queued = true;
        };
    };

    if(!streamon) {
        r = ioctl(fd,VIDIOC_STREAMON,&buf.type);
        if(r<0){
            perror("VIDIOC_STREAMON");
            exit(1);
        };
        streamon = true;
    };
    //if(r<0)perror("VIDIOC_STREAMON");

    fd_set fds;
    struct timeval tv;
    FD_ZERO (&fds);
    FD_SET (fd, &fds);

    /* Timeout. */
    tv.tv_sec = 1;
    tv.tv_usec = 500000;
    r = select (fd + 1, &fds, NULL, NULL, &tv);
    if (-1 == r) {
        perror("select");
        return false;
    };
    if (0 == r) {
        fprintf(stderr, "select timeout\n");
        cleanup();
        init_device();
        //ioctl(fd, VIDIOC_STREAMOFF);
        //start_device();
        //get_image();
        if(!get_image()){
            perror("get_image failed");
            exit(1);
        }else return get_image();
        //exit(EXIT_FAILURE);
    };
    int k;
    for(k=0; k<10; ++k) {
        for(int i=0; i<n_buffers; ++i) {
            buf.index = i;
            r = ioctl(fd, VIDIOC_QUERYBUF, &buf);
            if((buf.flags & V4L2_BUF_FLAG_QUEUED) == 0 && (buf.flags & V4L2_BUF_FLAG_DONE)>0) { //buffer is ready
                goto dblbreak;
            };
        };
        std::cout<<"X";
        fflush(stdout);
        usleep(100);
    };
dblbreak:
    if(k==9) {
        pperror("Capturing failed");
        return false;
    };
    r = ioctl(fd, VIDIOC_DQBUF, &buf);
    if(r<0){
        perror("VIDIOC_DQBUF:");
        exit(1);
    };
    current = buf.index;
    buffer = buffers[current];
    buffers[current].queued = false;
    return true;
//deque_buff();
//return;
//current = !current;
//buf.index = current;
//
    /*
    for(int z=0; z<10; ++z) {
        //usleep(100);
        for(int i=0; i<2; ++i) {
            buf.index = i;
            r = ioctl(fd, VIDIOC_QUERYBUF, &buf);
            if(r<0)pperror("VIDIOC_QUERYBUF");
            //std::cout<<i<<" fl: "<<buf.flags<<"\n";
            if((buf.flags & V4L2_BUF_FLAG_QUEUED) == 0 && (buf.flags & V4L2_BUF_FLAG_DONE)>0) { //buffer is ready
                r = ioctl(fd, VIDIOC_DQBUF, &buf);
                if(r<0)perror("VIDIOC_DQBUF:");
                current = buf.index;
                buffer = buffers[current];
                return;
            };
        };
        std::cout<<"-";
        usleep(100);
    };
    cleanup();
    init_device();
    start_device();
    return;
    */
//   cleanup();
//   exit(0);

//std::cout<<"qued "<<((buf.flags & V4L2_BUF_FLAG_QUEUED)>0) <<", done "<< ((buf.flags & V4L2_BUF_FLAG_DONE)>0)<<"\n";
//std::cout<<"flags: "<<buf.flags<<"\n";
//};
//


//r = ioctl(fd,VIDIOC_STREAMON,&buf.type);
//if(r<0)perror("VIDIOC_STREAMON");
    /*
    int r;
    //struct v4l2_buffer buf;
    //buf.type = V4L2_BUF_TYPE_VIDEO_CAPTURE;
    //buf.memory = V4L2_MEMORY_MMAP;
    //buf.index = 0;
    //
    r = ioctl(fd,VIDIOC_QBUF,&buf);
    if(r<0)perror("VIDIOC_QBUF");
    //r = ioctl(fd,VIDIOC_STREAMON,&buf.type);
    //if(r<0)perror("VIDIOC_STREAMON");
    r = ioctl(fd, VIDIOC_DQBUF, &buf);

    //if(r<0)perror("VIDIOC_DQBUF");


    */
//filter dead pixels
    /*
    unsigned char * pbuf = (unsigned char *)buffer.start;
    for(int i = 0;i<width*(height-1)*2-2;i+=2){
    	int val = pbuf[i+1] << 8 | pbuf[i];
    	if(val<4000 || val>7000){
    		//int v = 8000;
    		//pbuf[i+1] = v/256;
    		//pbuf[i] = v%256;
    		pbuf[i+1] = pbuf[i+3];
    		pbuf[i] = pbuf[i+2];
    	};
    	//int v = 4000;
    	//if(pbuf[i+1]<10){
    	//	pbuf[i] = v%256;
    	//	pbuf[i+1] = v/256;
    	//};
    };
    */
};

/*
void camera::start_device() {
    //struct v4l2_buffer buf;
    //buf.type = V4L2_BUF_TYPE_VIDEO_CAPTURE;
    //buf.index = 0;
    //buf.memory = V4L2_MEMORY_MMAP;
    CLEAR(buf);
    int r;
    buf.type = V4L2_BUF_TYPE_VIDEO_CAPTURE;
    buf.memory = V4L2_MEMORY_MMAP;
    //buf.memory = V4L2_MEMORY_USERPTR;
    for(int i=0; i<n_buffers; ++i) {
        enque_buff(i);
    };


    //r = ioctl(fd,VIDIOC_QBUF,&buf);
    //if(r<0)perror("VIDIOC_QBUF");
    //buf.index = 1;
    //r = ioctl(fd,VIDIOC_QBUF,&buf);
    //if(r<0)perror("VIDIOC_QBUF");

    r = ioctl(fd,VIDIOC_STREAMON,&buf.type);
    if(r<0)perror("VIDIOC_STREAMON");

    fd_set fds;
    struct timeval tv;
    FD_ZERO (&fds);
    FD_SET (fd, &fds);
    // Timeout.
    tv.tv_sec = 0;
    tv.tv_usec = 500000;
    r = select (fd + 1, &fds, NULL, NULL, &tv);
    if(r<0)perror("select:");
    fflush(stdout);
    //	deque_buff();
    buf.index = 0;
    r = ioctl(fd, VIDIOC_DQBUF, &buf);
    if(r<0)perror("VIDIOC_DQBUF:");
    current = buf.index;
    buffer = buffers[current];

    printf("Stream on\n");
    //current = 0;
    fflush(stdout);
};
*/

camera::~camera() {
    cleanup();
};

void camera::find_device() {
    struct udev *udev;
    struct udev_enumerate *enumerate;
    struct udev_list_entry *devices, *dev_list_entry;
    struct udev_device *dev;

    /* Create the udev object */
    udev = udev_new();
    if(!udev)perror("Can't create udev");

    /* Create a list of the devices in the 'hidraw' subsystem. */
    enumerate = udev_enumerate_new(udev);


    //udev_enumerate_scan_subsystems(enumerate);



    udev_enumerate_add_match_subsystem(enumerate, "video4linux");
    //udev_enumerate_add_match_subsystem(enumerate, "usb");
    udev_enumerate_scan_devices(enumerate);


    devices = udev_enumerate_get_list_entry(enumerate);
    /* For each item enumerated, print out its information.
    udev_list_entry_foreach is a macro which expands to
    a loop. The loop will be executed for each member in
    devices, setting dev_list_entry to a list entry
    which contains the device's path in /sys. */


    int count = 0;
    udev_list_entry_foreach(dev_list_entry, devices) {
        const char *path = udev_list_entry_get_name(dev_list_entry);
        dev = udev_device_new_from_syspath(udev, path);
        const char* product = udev_device_get_sysattr_value(dev,"product");
        //if(!product)continue;
        //std::cout<<count<<") "<<path<<"\n ";fflush(stdout);
        //printf("%i): %s\n ",count,path);
        //continue;
        /* Get the filename of the /sys entry for the device
        and create a udev_device object (dev) representing it */
		//if(!dev)continue;
        /* usb_device_get_devnode() returns the path to the device node
        itself in /dev. */

        const char * node_path = udev_device_get_devnode(dev);
        //printf("Device Node Path: %s\n", node_path);
        //std::cout<< node_path<<" ";fflush(stdout);
        printf("%i) %s ",count,node_path);
        /* The device pointed to by dev contains information about
        the hidraw device. In order to get information about the
        USB device, get the parent device with the
        subsystem/devtype pair of "usb"/"usb_device". This will
        be several levels up the tree, but the function will find
        it.*/

        dev = udev_device_get_parent_with_subsystem_devtype(dev,"usb","usb_device");
        if(!dev)perror("Unable to find parent usb device.");

        /* From here, we can call get_sysattr_value() for each file
        in the device's /sys entry. The strings passed into these
        functions (idProduct, idVendor, serial, etc.) correspond
        directly to the files in the directory which represents
        the USB device. Note that USB strings are Unicode, UCS2
        encoded, but the strings returned from
        udev_device_get_sysattr_value() are UTF-8 encoded. */
        product = udev_device_get_sysattr_value(dev,"product");
        const char * vendor_s = udev_device_get_sysattr_value(dev,"idVendor");
        std::stringstream ss;
        ss << std::hex << vendor_s;
        ss >> dev_VID;
        const char * product_s = udev_device_get_sysattr_value(dev, "idProduct");
        ss.clear();
        ss << product_s;
        ss >> dev_PID;
        printf("  VID %s PID %s ",vendor_s, product_s);
        printf(" %s  %s ",
               udev_device_get_sysattr_value(dev,"manufacturer"),
               udev_device_get_sysattr_value(dev,"product"));
        const char * serial_s = udev_device_get_sysattr_value(dev, "serial");
        if(serial_s)printf(" %s",serial_s);
        printf("\n");
        if(strcmp(product,"PI-IMAGER")==0) {
			dev_serial = atoi(serial_s);
			//dev = udev_device_get_parent_with_subsystem_devtype(dev,"usb","usb_device");
			//printf("[%s]",udev_device_get_devnode(dev));
			//dev_path = udev_device_get_devnode(dev);//node_path;
			//dev_path = std::string("/sys")+udev_device_get_devpath(dev);
			//dev_path = std::string(udev_device_get_syspath(dev)) + udev_device_get_sysname(dev);
			//dev = udev_device_get_parent_with_subsystem_devtype(dev,"video4linux",0);
			//dev_path = udev_device_get_devnode(dev);
			//const char * subsys = udev_device_get_subsystem(dev);
			//const char * driver = udev_device_get_driver(dev);
			//const char * attr = udev_device_get_sysattr_value(dev,"access");
			//printf("\n[%s\n %s \n %s \n %s]\n",dev_path.c_str(),subsys,driver,attr);
			dev_path = node_path;
        };
        ++count;
        udev_device_unref(dev);
    };

    udev_enumerate_unref(enumerate);
    udev_unref(udev);
    if(dev_path.empty())pperror("Cannot find device");
};

void camera::init_device() {
    v4l2_capability caps;
    v4l2_input input;
    v4l2_format fmt;
    v4l2_fmtdesc fmtd;
    struct v4l2_frmsizeenum fmse;
    enum v4l2_buf_type type;
    //struct v4l2_buffer buf;
    struct v4l2_requestbuffers reqbuf;
    struct v4l2_cropcap cropcap;
    struct v4l2_crop crop;

    fd = open(dev_path.c_str(), O_RDWR | O_NONBLOCK);
    if(fd==-1)pperror(std::string("opening ")+dev_path);
    int r;
    CLEAR(caps);
    r = ioctl(fd,VIDIOC_QUERYCAP,&caps);
    if(r<0)pperror("VIDIOC_QUERYCAP");
    std::cout<<"caps.driver"<<" streaming:" <<((caps.capabilities & V4L2_CAP_STREAMING)>0)<<" readwrite: "<<((caps.capabilities & V4L2_CAP_READWRITE)>0);
    CLEAR(fmtd);
    fmtd.type = V4L2_BUF_TYPE_VIDEO_CAPTURE;
    printf("formats: ");
    fmtd.index=0;// take first available format
    r = ioctl(fd,VIDIOC_ENUM_FMT,&fmtd);
    if(r<0)pperror("VIDIOC_ENUM_FMT");
    printf("%s ",fmtd.description);
    fmse.pixel_format = fmtd.pixelformat;
    fmse.index = 0;//take first available resolution
    r = ioctl(fd, VIDIOC_ENUM_FRAMESIZES, &fmse);
    if(r<0)pperror("VIDIOC_ENUM_FRAMESIZES");
    printf("%ix%i \n",fmse.discrete.width,fmse.discrete.height);
    width = fmse.discrete.width;
    height = fmse.discrete.height;
    // frequiency

    struct v4l2_frmivalenum frmival;
    frmival.index = 0;
    frmival.pixel_format = fmtd.pixelformat;
    frmival.width = fmse.discrete.width;
    frmival.height = fmse.discrete.height;
    r = ioctl(fd, VIDIOC_ENUM_FRAMEINTERVALS, &frmival);
    if(r<0)pperror("VIDIOC_ENUM_FRAMEINTERVALS");
    frequency = frmival.discrete.denominator/frmival.discrete.numerator;
    // init crop
    //CLEAR(cropcap);
    //cropcap.type = V4L2_BUF_TYPE_VIDEO_CAPTURE;
    //r = ioctl(fd, VIDIOC_CROPCAP, &cropcap);
    //if(r<0)pperror("VIDIOC_CROPCAP");
    //CLEAR(crop);
    //crop.type = V4L2_BUF_TYPE_VIDEO_CAPTURE;
    //crop.c = cropcap.defrect;
    //r = ioctl(fd, VIDIOC_S_CROP, &crop);
    //if(r<0)pperror("VIDIOC_S_CROP");
    //

    //CLEAR(fmt);
    //fmt.type = V4L2_BUF_TYPE_VIDEO_CAPTURE;
    //fmt.fmt.pix.width = width;
    //fmt.fmt.pix.height = height;
    //fmt.fmt.pix.pixelformat = V4L2_PIX_FMT_YUYV;
    //fmt.fmt.pix.field = V4L2_FIELD_ANY;
    //r = ioctl(fd, VIDIOC_S_FMT, &fmt);
    //if(r<0)pperror("VIDIOC_S_FMT");

    // got device, allocate buffer
    /*
    CLEAR(reqbuf);
    reqbuf.type = V4L2_BUF_TYPE_VIDEO_CAPTURE;
    reqbuf.memory = V4L2_MEMORY_USERPTR;
    r = ioctl(fd, VIDIOC_REQBUFS, &reqbuf);
    for(int i = 0; i<2;++i){
        buffers[i].start = new short int[width*height];
        buffers[i].length = width*height*2;
    };
    printf("Init device\n");
    fflush(stdout);
    return;
    */

    CLEAR(reqbuf);
    reqbuf.type = V4L2_BUF_TYPE_VIDEO_CAPTURE;
    reqbuf.memory = V4L2_MEMORY_MMAP;
    reqbuf.count = n_buffers;
    r = ioctl(fd, VIDIOC_REQBUFS, &reqbuf);
    if(r<0)pperror("VIDIOC_REQBUFS");
    std::cout<<"# buffers: "<<reqbuf.count<<"\n";
    buf.type = V4L2_BUF_TYPE_VIDEO_CAPTURE;
    buf.memory = V4L2_MEMORY_MMAP;
    for(int i = 0; i<n_buffers; ++i) {
        buf.index = i;
        r = ioctl(fd, VIDIOC_QUERYBUF, &buf);
        if(r<0)pperror("VIDIOC_QUERYBUF");
        buffers[i].length = buf.length;
        buffers[i].start = mmap (NULL, buf.length, PROT_READ | PROT_WRITE, /* recommended */ MAP_SHARED, /* recommended */ fd, buf.m.offset);
        buffers[i].queued = false;
    };
    //
    printf("Init device\n");
    fflush(stdout);
    current = 0;
    streamon = false;
};



void camera::cleanup() {
    if(fd>0) {
        ioctl(fd, VIDIOC_STREAMOFF);
        for(int i=0; i<n_buffers; ++i) {
            munmap(buffers[i].start, buffers[i].length);
            //delete buffers[i].start;
        };
        close(fd);
        fd=-1;
    };
};


