#include <string>
#include <map>
#include "EasyImagerDLL/EasyImgProc/ImgProc.h"
#include "EasyImagerDLL/ImagerHID/ImagerHID.h"

class imager_filter : public ImageProcessing{
    public:
    typedef ImageProcessing parent;
public:
    ImagerHID HID;
public:
	void * input_buffer;
    float TempChip;
	float TempFlag;
	float TempBox;
	float TempChip1;
	TFlagState frameFlagState;
	short int * out_buffer;
	long long Timestamp;
	int width;
	int height;
	bool frame_processed;
	std::map<int,float> kennelinie;
public:
	imager_filter();
	~imager_filter();
	void init(const std::wstring & cali_path, int width, int height, int frequency, int dev_serial, unsigned int dev_VID, unsigned int dev_PID);
	void filter_image(void * buffer);
	void reinit();
	TFlagState GetFlag();
	void SetFlag(const TFlagState &fl);
private:
	long long frame;
	int FOV;
	float TRmin;
	float TRmax;
	unsigned int dev_VID;
	unsigned int dev_PID;
	int serial;
	int frequency;
public:
	void OnFrame(void * out_buffer);
private:
	//long SetOpticsAndTemprange(unsigned short ImgIndex, int FieldOfView, float TempRangeMin, float TempRangeMax);
};
