//#define NOMNMAX
#include "imager_filter.h"

#include <string.h>
#include <wchar.h>

#include <stdlib.h>
#include "error.h"

#include <stdio.h>
#include <wchar.h>
#include <iostream>
#include <fstream>

#include "EasyImagerDLL/Imager.h"


imager_filter * the_filter;

void CBOnFrameInit(WORD ImgIndex, PFrameConfig Config){
	int o_width = Config->Width;
	int o_height = Config->Height;
};

void CBOnFrame(WORD ImgIndex, PFrameBuffer Buffer){
	//printf(".");
	//fflush(stdout);
	the_filter->TempChip = Buffer->metadata->TempChip;
	the_filter->TempFlag = Buffer->metadata->TempFlag;
	the_filter->TempBox = Buffer->metadata->TempBox;
	the_filter->OnFrame(Buffer->data);
};

imager_filter::imager_filter(){
	the_filter = this;
};

imager_filter::~imager_filter(){
	delete out_buffer;
};

void imager_filter::init(const std::wstring & cali_path, int width, int height, int frequency, int serial, unsigned int dev_VID, unsigned int dev_PID){
	this->width = width;
	this->height = height;
	frame = 0;
    frame_processed = true;
    out_buffer = new short int[width*height];

    FrameConfig frameconfig ={width,height,16,10000000/frequency};
    ImgProcConfig config;
    config.SerialNumber = serial;
    for(int i=0; i<IPDataTypeCOUNT; i++){
            config.OnFrame[i] = NULL;
            config.OnFrameInit[i] = NULL;
    };

	config.OnFrame[ipdtEnergy] = &CBOnFrame;
	config.OnFrameInit[ipdtEnergy] = &CBOnFrameInit;
	wcscpy(config.ConfigDirectory,cali_path.c_str());
	wcscpy(config.CaliDirectory,(cali_path+L"/Cali").c_str());
	wcscpy(config.ApplDirectory,cali_path.c_str());

//    wcscpy(config.CaliDirectory, L"/usr/lib/imager/Cali");
//    wcscpy(config.ApplDirectory, L"/usr/lib/imager");
//
//    wcscpy(config.ConfigDirectory,L"/usr/lib/imagerr");
//    wcscpy(config.CaliDirectory, L"/usr/lib/imager/Cali");
//    wcscpy(config.ApplDirectory, L"/usr/lib/imager");
//    SGBuffer[ImgIndex].Timestamp = new long long;
//    SGBuffer[ImgIndex].TimestampMedia = new long long;
//    *(SGBuffer[ImgIndex].Timestamp) = 0;
	CreateImagers(1);
	NewFrameBuffer nb;
	nb.data = 0;
	//nb.Timestamp = 0;
	//nb.TimestampMedia = 0;
	long long tt = timeGetTime()*1e4;
	nb.Timestamp = &tt;
	nb.TimestampMedia = &frame;
    int hr = ConfigImageProcessing(0,&config,&frameconfig,&nb.data);
    input_buffer = nb.data;
    if(FAILED(hr)){
        if(hr == -2){
            WCHAR MissingCaliFilename[1024];
            ::GetMissingCaliFilename(0, MissingCaliFilename, 1024);
            WCHAR ErrorString[2048];
            wcscpy(ErrorString,L"Error loading calibration file\n");
            wcscat(ErrorString,config.CaliDirectory);
            wcscat(ErrorString,L"/");
            wcscat(ErrorString,MissingCaliFilename+2);
            std::wcout<<"\n"<<ErrorString<<"\n";
            fflush(stdout);
            exit(1);
        }
        else{
            //wcscpy(ErrorString, L"Error configuring image processing");
            //return hr;
            pperror("configuring image processing");
        }
    }
    //if(!CheckSuccess(hr, L"Error initializing image processing"))
    //    return hr;

    unsigned short HWRev,FWRev;
    unsigned long PifSer;
    bool limitFram;

    SetHIDLog(0, 5, L"HIDLog.txt");

    hr = ConfigHID(0,dev_VID,dev_PID,serial,&HWRev,&FWRev,&PifSer,&limitFram);
    if(hr<0)pperror("ConfigHID");
    this->dev_VID = dev_VID;
    this->dev_PID = dev_PID;
    this->serial = serial;
    //if(!CheckSuccess(hr, L"Error configuring HID device"))
    //    return hr;
	//
    //return 0;

//	hr = ::SetOpticsAndTemprange(0, 0, 0, 0);

	int TempRangeCount;
	hr = ::GetCaliOpticsFOV(0, 0, &FOV);
	printf("FOV: %i\n",FOV);
	if(hr<0)pperror("GetCaliOpticsFOV");
    hr = ::GetCaliTempRangeCount(0,FOV, &TempRangeCount);
    printf("TempRangeCount: %i\n",TempRangeCount);
    for(int i=0;i<TempRangeCount;++i){
        if(hr<0)pperror("GetCaliTempRangeCount");
        hr = ::GetCaliTempRangeMin(0, FOV, i, &TRmin);
        if(hr<0)pperror("GetCaliTempRangeMin");
        hr = ::GetCaliTempRangeMax(0, FOV, i, &TRmax);
        if(hr<0)pperror("GetCaliTempRangeMax");
        printf("TempRange(%i): %4.2f %4.2f\n",i,TRmin,TRmax);
    };
	//exit(0);
	//use range 0
    hr = ::GetCaliTempRangeMin(0, FOV, 0, &TRmin);
    hr = ::GetCaliTempRangeMax(0, FOV, 0, &TRmax);
	hr = ::SetOpticsAndTemprange(0,FOV,TRmin,TRmax);
    printf("SetOpticsAndTemprange returns %i\n",hr);
//	exit(0);
//   hr = ::GetCaliOpticsFOV(0, 0, &FOV);
//	if(hr<0)pperror("GetCaliOpticsFOV");
//	hr = ::GetCaliTempRangeMin(0, FOV, 0, &TRmin);
//	if(hr<0)pperror("GetCaliTempRangeMin");
//	hr = ::GetCaliTempRangeMax(0, FOV, 0, &TRmax);
    //if(hr<0)pperror("Error setting optics field of view or temprange!");

    hr = InitImageProcessing(0);
    if(hr<0)pperror("InitImageProcessing");


	hr = ::SetFramerate(0, frequency);
	if(hr<0)pperror("SetFramerate");
	hr = ::SetReduceMode(0, rmAvg);
	if(hr<0)pperror("SetReduceMode");
    hr = ::SetFrameIntervalAvgExt(0, 1);
    if(hr<0)pperror("SetFrameIntervalAvgExt");
//
    hr = ::StartFlag(0);
    if(hr<0)pperror("StartFlag");
//
//
const std::string fname = std::string(cali_path.begin(), cali_path.end() )+"/Cali/Kennlinie-12050017-48-0-250.prn";
std::cout<<fname.c_str()<<"\n";
std::ifstream f(fname.c_str());
//    FILE * f = fopen((cali_path+L"Kennlinie-12050017-48-0-250.prn").c_str(),"r");
    while(!f.eof()){
        int x;
        float y;
        //fscanf(f,"%f %f",&x,&y);
        f >>x >> y;
        //std::cout<<x<<" "<<y<<"\n";
        kennelinie.insert(std::pair<int,float>(x,y));
    };
//
    printf("Init imager\n");
    fflush(stdout);
    this->frequency = frequency;
};

void imager_filter::reinit(){
     unsigned short HWRev,FWRev;
    unsigned long PifSer;
    bool limitFram;
    int hr;
    //hr = ConfigHID(0,dev_VID,dev_PID,serial,&HWRev,&FWRev,&PifSer,&limitFram);
    //if(hr<0)pperror("ConfigHID");
    //hr = ::SetOpticsAndTemprange(0,FOV,0,0);
	//hr = ::SetOpticsAndTemprange(0,FOV,TRmin,TRmax);
    //printf("SetOpticsAndTemprange returns %i\n",hr);
    //hr = ::SetFramerate(0, frequency);
	//if(hr<0)pperror("SetFramerate");
	//hr = ::SetReduceMode(0, rmOff);
	//if(hr<0)pperror("SetReduceMode");
    //hr = ::SetFrameIntervalAvgExt(0, 1);
    //if(hr<0)pperror("SetFrameIntervalAvgExt");
    hr = ::StartFlag(0);
    //if(hr<0)pperror("StartFlag");
    //::SetFlag(0,fsFlagClose);
};
/*
long imager_filter::SetOpticsAndTemprange(unsigned short ImgIndex, int FieldOfView, float TempRangeMin, float TempRangeMax){
        HRESULT hr = S_OK;
        int FOV;
        float TRmin, TRmax;

        hr =::SetOpticsAndTemprange(ImgIndex, FieldOfView, TempRangeMin, TempRangeMax);
        if(hr >= 0) return hr;

        // may be FieldOfView does not exist and we have to use 0. FOV:
        if((::GetCaliOpticsFOV(ImgIndex, 0, &FOV)) >= 0)
        {
                hr = ::SetOpticsAndTemprange(ImgIndex, FOV, TempRangeMin, TempRangeMax);
                if(hr >= 0) return hr;
        }

        // may be Temprange does not exist and we have to use 0. TR:
        if(SUCCEEDED(::GetCaliTempRangeMin(ImgIndex, FieldOfView, 0, &TRmin)) &&
                SUCCEEDED(::GetCaliTempRangeMax(ImgIndex, FieldOfView, 0, &TRmax)))
        {
                hr = ::SetOpticsAndTemprange(ImgIndex, FieldOfView, TRmin, TRmax);
                if(SUCCEEDED(hr)) return hr;
        }

        // FieldOfView and Temprange does not exist and we have to use 0. FOV and 0. TR:
        if(SUCCEEDED(::GetCaliOpticsFOV(ImgIndex, 0, &FOV)) &&
                SUCCEEDED(::GetCaliTempRangeMin(ImgIndex, FOV, 0, &TRmin)) &&
                SUCCEEDED(::GetCaliTempRangeMax(ImgIndex, FOV, 0, &TRmax)))
                return ::SetOpticsAndTemprange(ImgIndex, FOV, TRmin, TRmax);
        return -1;
}
*/

//HRESULT imager_filter::SetDisplayFramerate(WORD ImgIndex, double Val){
//        return ::SetFramerate(ImgIndex, Val);
//}

//HRESULT imager_filter::SetReduceMode(WORD ImgIndex, TReduceMode Val){
//       return ::SetReduceMode(ImgIndex, Val);
//}

//HRESULT imager_filter::SetFlag(WORD ImgIndex, TFlagState Val){
//        ::SetFlag(ImgIndex, Val);
//}

//HRESULT imager_filter::StartFlag(WORD ImgIndex){
//    ::StartFlag(ImgIndex);
//}

int imager_filter::get_flag(){
    TFlagState fl;
    ::GetFlag(0,&fl);
    return fl;
};

void imager_filter::filter_image(void * buffer){
	//if(!frame_processed)return;
	memcpy(input_buffer,buffer,width*height*2);
	NewFrameBuffer nb;
	nb.data = input_buffer;
	long long tt = timeGetTime()*1e4;
	nb.Timestamp = &tt;//timeGetTime()*1e4;
	++frame;
	nb.TimestampMedia = &frame;
	frame_processed = false;
	::NewFrame(0,&nb);
/*
	for(;;){
        ::GetFlag(0,&fl);
        //std::cout<<fl<<"\n";
        if(fl==fsFlagOpen)break;
        usleep(100);
        tt = timeGetTime()*1e4;
        nb.Timestamp = &tt;//timeGetTime()*1e4;
        ++frame;
        nb.TimestampMedia = &frame;
        frame_processed = false;
        NewFrame(0,&nb);
        while(!frame_processed){
            usleep(100);
        };
	};
*/
	while(!frame_processed){
		usleep(100);
	};
};

void imager_filter::OnFrame(void * out_buffer){
	//this->out_buffer = out_buffer;
	// recode output buffer to integers
	::GetCurrentBuffer(0,ipdtEnergy,width*height*2,this->out_buffer);
	//::GetCurrentBuffer(0,ipdtTemp,width*height*2,this->out_buffer);

/*
	for(int i = 0; i < width*height; ++i){
		this->out_buffer[i] = kennelinie[this->out_buffer[i]];
	};
*/

//	short int *  ibuf = this->out_buffer;
//	uchar * cbuf = (uchar*)out_buffer;
//	for(int i = 0; i < width*height; ++i){
//		ibuf[i] = cbuf[2*i+1] << 8 | cbuf[2*i];
//	};

	//memcpy(this->out_buffer,out_buffer,width*height*2);
	frame_processed = true;
};
