//#include <ros/ros.h>
//#include <image_transport/image_transport.h>
//#include <sensor_msgs/image_encodings.h>

#include "camera.h"
#include "imager_filter.h"
#include <stdio.h>
#include "error.h"


#include "IronPalette.h"
#include <QtGui/QApplication>
#include <QtGui/QLabel>
#include <QtCore/QBasicTimer>
#include <QtGui/QPainter>
#include <QtGui/QDialog>

#include <string>
#include <iostream>
#include <fstream>
#include <time.h>
//#include <ctime>

#include <cmath>

//#include "EasyImagerDLL/Imager.h"

/*
int main(int argc, char **argv){
	ros::init(argc, argv, "thermo_node");
	ros::NodeHandle nh;
	if(argc<2){
		pperror("one argument expected - path to calibration folder");
	};
	std::string arg1 = argv[1];
	std::wstring cali_path = std::wstring(arg1.begin(),arg1.end());//;L"/usr/lib/imager";
	std::wcout<<"Config pth: "<<cali_path<<"\n";
	//
	camera cam;
	imager_filter imager;
	cam.find_device();
	cam.init_device();
	imager.init(cali_path,cam.width,cam.height,cam.frequency,cam.dev_serial,cam.dev_VID,cam.dev_PID);
	//
	//
	//if(argc<2){
	//	throw debug_exception("one argument expected - path to detector config");
	//};
	//char* path = argv[1];
	//fprintf(stderr,"Starting wb_detector %s\n",path);
	image_transport::ImageTransport it(nh);
	image_transport::Publisher publisher = it.advertise("thermo_camera/image", 1);

    while (nh.ok()){
		ros::spinOnce();
		sensor_msgs::ImagePtr msg(new sensor_msgs::Image());
		//
		//get image from thermo camera
		cam.get_image();
		msg->header.stamp = ros::Time::now();
		imager.filter_image(cam.buffer.start);
		//
		// publish it
		int num_bytes = cam.width*(cam.height-1)*2;
		msg->data.resize(num_bytes);
		memcpy(&msg->data[0],imager.out_buffer,num_bytes);
		msg->encoding = sensor_msgs::image_encodings::MONO16;
		msg->step = 2*cam.width;
		msg->height = cam.height-1;
		msg->width = cam.width;
		msg->header.frame_id = "/omni_frame";
		msg->header.seq = 0;
		publisher.publish(msg);
    };
};
*/

class myApp : public QApplication {
public:
    camera cam;
    imager_filter imager;
//	struct{int width; int height;} cam;
    QImage img;
    QLabel label;
    QLabel * ll[3][3];
    QLabel * info;
    int count;
    int cali_count;
    std::ofstream log1;
    //std::ofstream cali_log;
    struct temp_measure {
        float energy;
        float chip;
        float box;
        float flag;
        float chip1;
        float ee[9];
    };
    std::vector<temp_measure> hist;
    int flag_count;
    unsigned short * cali;
    float Tref;
public:
    //myApp(int argc, char* argv[]):QApplication(argc,argv){
    myApp(int & argc, char **argv):QApplication(argc,argv) {
//	    label->resize(200,200);
//	    label->show();
//	    return;
        count = 0;
        if(argc<2) {
            pperror("one argument expected - path to calibration folder");
        };
        std::string arg1 = argv[1];
        std::wstring cali_path = std::wstring(arg1.begin(),arg1.end());//;L"/usr/lib/imager";
        //std::cout<<"Config pth: "<<cali_path<<"\n";

        cam.find_device();
        cam.init_device();
        //cam.cleanup();
        //exit(0);
        //cam.cleanup();
        //std::wstring cali_path = L"/usr/lib/imager";
        imager.init(cali_path,cam.width,cam.height,cam.frequency,cam.dev_serial,cam.dev_VID,cam.dev_PID);
        //ReleaseImagers();
        //imager.init(cali_path,cam.width,cam.height,cam.frequency,cam.dev_serial,cam.dev_VID,cam.dev_PID);
        //cam.init_device();
        //cam.start_device();
        //
        //cam.width = 200;
        //cam.height = 100;
        img = QImage(cam.width, cam.height-1, QImage::Format_RGB32);
        img.fill(QColor(0,0,0));
        label.setScaledContents(true);
        label.resize(cam.width*4,cam.height*4);
        label.show();
        for(int i=0; i<3; ++i) {
            for(int j=0; j<3; ++j) {
                QLabel * l= new QLabel(&label);
                //l->setFont
                //l->setAlignment( int( QLabel::AlignLeft | QLabel::AlignTop) );
                l->setText("36.6");
                l->move(cam.width*(j+1),cam.height*(i+1));
                //QFont f = l->font();
                //f.setPointSize(32);
                //l->setFont(f);
                //l->adjustSize();
                l->show();
                ll[i][j] = l;
            };
        };
        ///
        info = new QLabel(&label);
        info->setText("Info");
        info->move(10,10);
        info->show();
        flag_count = 0;
        ///
        int framerate = 100;
        imager.TempChip = 1e-5;
        log1.open("log.txt");
        cali = new unsigned short[cam.width*(cam.height-1)];
        cali_count = 0;
        startTimer(1000*1/framerate);

    };
    ~myApp() {
    };


    void timerEvent ( QTimerEvent * event ) {
        int Width = cam.width;
        int Height = cam.height-1;
        //cam.get_image();
        //std::cout<<".";
        //return;
        //TFlagState fl = imager.GetFlag();
        //if(fl!=fsFlagOpen && fl!=fsFlagClose){//the flag is moving, do not grab image
        //    return;
        //};
        //
        cam.get_image();
        imager.filter_image(cam.buffer.start);
        //
        if(++count==1)return;
        //
        //TFlagState fl = imager.GetFlag();
        TFlagState fl = imager.frameFlagState;
        //TFlagState fl = fsFlagClose;
        std::cout<<fl<<" ";
        fflush(stdout);
        if(fl!=fsFlagOpen) {
            std::cout<<".";
            //if(fl==fsFlagClose){
            if(++flag_count>=5) {
                imager.SetFlag(fsFlagOpen);
                flag_count=0;
            };
            //};
            //return;
        };

        if(fl!=fsFlagOpen && fl!=fsFlagClose) { //the flag is moving, do not use image
            return;
        };

        //todo: should avoid crossing of frame acquisition and flag control?
        ++cali_count;
        if(fl==fsFlagOpen && std::abs(imager.TempChip-imager.TempChip1)>=0.2 || cali_count>50) {
            std::cout<<"Recalibrating for chip temperature: "<< imager.TempChip<<"\n";
            imager.SetFlag(fsFlagClose);
            imager.TempChip1 = imager.TempChip;
            flag_count=0;
            cali_count=0;
        };
        /*
                if(0) { //count==0 || std::abs(imager.TempChip-imager.TempChip1)>=1){// && 0){
                    imager.reinit();
                    //clock_t t1=clock();
        //	        timeval tim;
        //            gettimeofday(&tim,NULL);
        //            double t1 = tim.tv_sec+double(tim.tv_usec)/1000000.0;
                    for(int k=0;; ++k) {
                        cam.get_image();
                        imager.filter_image(cam.buffer.start);
                        if(k==0)std::cout<<"Chip temperature: "<< imager.TempChip<<", recalibrating\n";
                        std::cout<<".";
                        fflush(stdout);
                        //fflush(stdout);
        //                gettimeofday(&tim,NULL);
        //                double t2 = tim.tv_sec+double(tim.tv_usec)/1000000.0;
                        //std::cout<<t2-t1<<"\n";
        //                if((t2-t1)>4)break;
                        if(k>5 && imager.GetFlag()==0) {
                            std::cout<<"\n.";
                            break;
                        };
                    };
                    imager.TempChip1 = imager.TempChip;
                };
                */
        //fprintf();
        const char * psym = "-\\|/";
        //std::cout<<"\b\b"<<psym[count % 4]<<fl;
        //std::cout<<fl<<" ";
        fflush(stdout);
        /*
        if(++count>50){
            imager.reinit();
            count = 0;
            //return;
        };
        */
        //usleep(10000);
        //for(int k=0;k<5;++k){
        //cam.get_image();
        //};
        //imager.filter_image(cam.buffer.start);
        //if(imager.get_flag()!=0)return;
        float * vals = new float[Width*Height];

        if(fl==fsFlagClose) { //save reference
            memcpy(cali,cam.buffer.start,Width*Height*2);
            //
            //for(int i = 0; i < (Width) * (Height); ++i) {
            //    vals[i] = (float)cali[i];
            //};
            Tref = imager.TempFlag;
            return;
        } else {
            //memcpy(imager.out_buffer,cam.buffer.start,cam.width*(cam.height-1)*2);
            unsigned short * pcam = (unsigned short *)cam.buffer.start;
            for(int i = 0; i < (Width) * (Height); ++i) {
                vals[i] = (float)pcam[i]-(float)cali[i];
                //vals[i] = cali[i];
            };
        };
        //unsigned short * vals = (unsigned short*)imager.out_buffer;
        //for(int i = 0; i < (Width) * (Height); ++i) {
        //    vals[i] = vals[i]-cali[i];
        //vals[i] = cali[i];
        //};


        //memcpy(imager.out_buffer,cam.buffer.start,cam.width*cam.height*2);
        //
        // display image
        QRgb * pimg = (QRgb*)img.bits();
        //uchar * pbuf = (uchar*)(imager.out_buffer);
        uchar * pc = (uchar*)(cam.buffer.start);
        float max=-1e6;
        float min=+1e6;
        float * vals1 = new float[Width*Height];


        //median filter
        std::vector<float> a;
        a.resize(9);
        memset(vals1,0,Width*Height*sizeof(float));
        for(int i=1; i<Height-1; ++i) {
            for(int j=1; j<Width-1; ++j) {
                /*
                int l =0;
                a.clear();
                for(int i1=-1;i1=0;i1+=2){
                    for(int j1=-1;j1=0;j1+=2){
                        if(i+i1<0 | i+i1>=Height | j+j1<0 | j+j1>=Width)continue;
                        a.push_back()
                    };
                };
                */
                int ii = i*Width+j;
                a[0] = vals[ii];
                a[1] = vals[ii+1];
                a[2] = vals[ii-1];
                a[3] = vals[ii-Width];
                a[4] = vals[ii+Width];
                a[5] = vals[ii-1-Width];
                a[6] = vals[ii-1+Width];
                a[7] = vals[ii+1-Width];
                a[8] = vals[ii+1+Width];
                std::nth_element(a.begin(),a.begin()+5,a.end());
                int pixel = a[5];
                vals1[ii] = pixel;
                if(pixel > max)max = pixel;
                if(pixel < min)min = pixel;
            };
        };
        //int * vals = new int[Width * (Height-1)];
        /*
        		for(int i = 0; i < (Width) * (Height-1); ++i){
        		    //vals[i] = pc[2*i+1] << 8 | pc[2*i];
        		    //if(vals[i]<4000){
        		    	//vals[i] = vals[i+1];//pc[2*(i+1)+1] << 8 | pc[2*(i+1)];
        		    //};
        		};
        */

        /*
        		for(int i = 0; i < (Width) * (Height-1); ++i){
        		    int pixel = vals1[i];
        			if(pixel > max)max = pixel;
        			if(pixel < min)min = pixel;
        		};
        */

        //min = 1900;
        //max = 8000;
        //min = 1200;
        //max = 2000;
        //printf("\n[ %i %i]",min,max);

        for(int i = 0; i < (Width) * (Height); ++i) {
            int pixel = vals1[i];
            int a = std::min(239,std::max(0,int((pixel-min)*240/(max-min+1))));
            pimg[i] = qRgb(Iron[a][0],Iron[a][1],Iron[a][2]);
        };
//		// tell the painter to draw on the QImage
//		QPainter painter(&img); // sorry i forgot the "&"
//		painter.setPen(Qt::black);
//		painter.setFont(QFont("Arial", 10));
        // you probably want the to draw the text to the rect of the image
//		painter.drawText(img.rect(), Qt::AlignCenter, "Text on Image");
//		sstream ss;
        char * s[1024];
        temp_measure m;
        m.chip = imager.TempChip;
        m.box = imager.TempBox;
        m.flag = imager.TempFlag;
        m.chip1 = imager.TempChip1;
        QPainter painter(&img);
        painter.setPen(QPen(Qt::white, 1));
        for(int i=0; i<4; ++i) {
            painter.drawLine(Width/8+Width/4*i,Height/8,Width/8+Width/4*i,Height*7/8);
            painter.drawLine(Width/8,Height/8+Height/4*i,Width*7/8,Height/8+Height/4*i);
        };
        for(int i=0; i<3; ++i) {
            for(int j=0; j<3; ++j) {
                float temp = 0;
                int n = 0;
                for(int i1 = -Height/8; i1<Height/8; ++i1) {
                    for(int j1 = -Width/8; j1<Width/8; ++j1) {
                        int jj = Width/4*(j+1)+j1;
                        int ii = (Height/4)*(i+1)+i1;
                        temp+= vals1[jj+ii*Width];
                        ++n;
                    };
                };
                temp/=n;
                if(i==1 && j==1)m.energy = temp;
                m.ee[i*3+j] = temp;
                sprintf((char*)s,"%3.1f",temp);
                //sprintf((char*)s,"%3.1f",temp*0.0353+6.13+Tref);// +70 - imager.TempChip);
                //sprintf((char*)s,"%3.1f",imager.kennelinie[temp]-Tref+imager.TempChip);
                ll[i][j]->setText(QString("<font color='white' size='8'>")+(char*)s+QString("</font>"));
                ll[i][j]->adjustSize();
                label.setPixmap(QPixmap::fromImage(img));
            };
        };
        //
        sprintf((char*)s,"temperature chip: %3.1f, flag: %3.1f, box: %3.1f",imager.TempChip,imager.TempFlag, imager.TempBox);
        info->setText(QString("<font color='black' size='6'>")+(char*)s+QString("</font>"));
        info->adjustSize();
        //delete vals;
        delete vals1;
        delete vals;
        hist.push_back(m);

        //std::ofstream ff("log.txt");
        //for(int i=0;i<hist.size();++i){
        //log1<<hist[i].energy<<" "<<hist[i].chip<<" "<<hist[i].box<<" "<<hist[i].flag<<" "<< hist[i].chip1<<"\n";
        //};
        //ff.flush();
        log1<<m.energy<<" "<<m.chip<<" "<<m.box<<" "<<m.flag<<" "<< m.chip1<<" ";
        for(int i=0;i<9;++i)log1<<m.ee[i]<<" ";
        log1<<double(imager.Timestamp)/10000000.0<<"\n";
        log1.flush();
    };
};


int main (int argc, char *argv[]) {
    myApp a(argc, argv);
    //QApplication a(argc, argv);
    //QDialog d;
    //d.show();
    //QLabel l;
    //l.resize(200,200);
    //l.show();
    //////////////////////////////////
    //for(int i=0;i<100;++i){
    //	a.vid.get_image();
    //	sleep(100);
    //};

    return a.exec();
}

/*
void imageCallback(const sensor_msgs::ImageConstPtr & msg){
	//printf("!");
};
*/

