//#include <ros/ros.h>
//#include <image_transport/image_transport.h>
//#include <sensor_msgs/image_encodings.h>

#include "camera.h"
//#include "imager_filter.h"
#include <stdio.h>
#include "error.h"

#include "IronPalette.h"
#include <QtGui/QApplication>
#include <QtGui/QLabel>
#include <QtCore/QBasicTimer>
#include <QtGui/QPainter>
#include <QtGui/QDialog>
#include <QtGui/QKeyEvent>
#include <QtGui/QMouseEvent>

#include <string>
#include <iostream>
#include <fstream>
#include <time.h>
//#include <ctime>

#include <cmath>

#include "include/Imager.h"
#include "ImagerUVC.h"

#define MATLAB
#ifdef MATLAB
    #include "mex/mex_io.h"
    #undef printf
#endif

#include <sstream>

#define NO_EXTTYPE
#include <stdio.h>
#include "exttype/intn.h"
#include "dynamic/dynamic.h"
#include "debug/performance.h"

using namespace optris;


fptrOptrisFrame pOnFrame;

//void cbOnFrame(unsigned short* image, unsigned int w, unsigned int h);

class myApp : public QApplication {
public:
    camera cam;
//    ImagerUVC uvc;

//    imager_filter imager;
    Imager * imager;
    int Width;
    int Height;
    bool frame_processed;
//	struct{int width; int height;} cam;
    QImage img;
    QLabel label;
    QLabel * ll[3][3];
    QLabel * info;
    int count;
    int cali_count;
    std::ofstream log1;
    int o_count;
    //std::ofstream cali_log;
    struct temp_measure {
        float energy;
        float chip;
        float box;
        float flag;
        float chip1;
        float ee[9];
    };
    std::vector<temp_measure> hist;
    std::vector<unsigned short int> imager_v;
    int flag_count;
    unsigned short * cali;
    float Tref;
    unsigned char * buff;
public:
    //myApp(int argc, char* argv[]):QApplication(argc,argv){
    myApp(int & argc, char **argv):QApplication(argc,argv),buff(0) {
//	    label->resize(200,200);
//	    label->show();
//	    return;
        count = 0;
        o_count = 0;
        #ifdef MATLAB
        start_engine();
        engEvalString(matlab, "a=1");
        #endif
        //if(argc<2) {
        //    pperror("one argument expected - path to calibration folder");
        //};
        //std::string arg1 = argv[1];
        //std::wstring cali_path = std::wstring(arg1.begin(),arg1.end());//;L"/usr/lib/imager";
        //std::cout<<"Config pth: "<<cali_path<<"\n";


        cam.find_device();
        cam.init_device();
        //cam.cleanup();
        Width = cam.width;
        Height = cam.height-1;
        imager = new Imager(cam.dev_serial,cam.width,cam.height,cam.frequency,"../data/config/12050017.xml");//argv[1]);
        imager->setAutoflagControl(false);
        imager->forceRecalibration();

/*
            unsigned long serial = uvc.FindFirstDevice();
        	if(serial==0){
        		std::cout << "Error finding imager device" << std::endl;
        		exit(1);
        	}

        	if(uvc.OpenDevice()!=0){
        		std::cout << "Error opening UVC device: " << uvc.GetPath() << std::endl;
        		exit(1);
        	}
                imager = new Imager(serial, uvc.GetWidth(), uvc.GetHeight(), uvc.GetFrequency(), argv[1]);
                Width = uvc.GetWidth();
                Height = uvc.GetHeight()-1;

                //cam.cleanup();
                //exit(0);
                //std::wstring cali_path = L"/usr/lib/imager";
                //imager.init(cali_path,cam.width,cam.height,cam.frequency,cam.dev_serial,cam.dev_VID,cam.dev_PID);
                imager->setAutoflagControl(true);
                uvc.Start();
*/

        //cam.init_device();

        //ReleaseImagers();
        //imager.init(cali_path,cam.width,cam.height,cam.frequency,cam.dev_serial,cam.dev_VID,cam.dev_PID);
        //cam.init_device();
        //cam.start_device();
        //
        //cam.width = 200;
        //cam.height = 100;

        img = QImage(Width, Height, QImage::Format_RGB32);
        img.fill(QColor(0,0,0));
        label.setScaledContents(true);
        label.resize(Width*4,Height*4);
        label.show();
        for(int i=0; i<3; ++i) {
            for(int j=0; j<3; ++j) {
                QLabel * l= new QLabel(&label);
                //l->setFont
                //l->setAlignment( int( QLabel::AlignLeft | QLabel::AlignTop) );
                l->setText("36.6");
                l->move(Width*(j+1),Height*(i+1));
                //QFont f = l->font();
                //f.setPointSize(32);
                //l->setFont(f);
                //l->adjustSize();
                l->show();
                ll[i][j] = l;
            };
        };
        ///
        info = new QLabel(&label);
        info->setText("Info");
        info->move(10,10);
        info->show();
        flag_count = 0;
        ///
        int framerate = 100;
        //imager.TempChip = 1e-5;
        log1.open("log.txt");
        cali = new unsigned short[Width*Height];
        buff = new unsigned char[Width*(Height+1)*2];
        cali_count = 0;
        /*
        std::cout<<"Spin-up  ";
        for(int i=0;i<500;++i){
            ++count;
            const char * psym = "-\\|/";
            std::cout<<"\b"<<psym[count % 4];fflush(stdout);
            uvc.GetFrame(buff);
            memset(buff,0,Width*(Height+1)*2);
            imager->process(buff);
            uvc.ReleaseFrame();
        };
        */
        imager->setFrameCallback(pOnFrame);
        std::cout<<"\n";
        startTimer(1000/framerate);
    };
    ~myApp() {
        delete imager;
        if(buff)delete buff;
    };

    void save_images() {
    #ifdef MATLAB
        //o_count = 1;

        dynamic::num_array<unsigned short int,3> brust;
        dynamic::num_array<double,1> tt;
        int n_frames = 1000;
        brust.resize(exttype::mint3(Width,Height+1,n_frames));
        tt.resize(n_frames);
        debug::PerformanceCounter c1;
        c1.start();
        for(int i=0;i<n_frames;++i){
            cam.get_image();
            tt(i) = c1.time();
            memcpy(&brust(0,0,i),cam.buffer.start,cam.buffer.length);
        };
        std::cout<<" recording ";
        //fflush(stdout);
        //imager->process((unsigned char *)cam.buffer.start);
        {
            eng_out(brust,"brust");
            eng_out(tt,"tt");
            //eng_out(src.rgb,"X");
            {
                std::stringstream ss;
                ss<<"frames{"<<o_count+1<<"}.brust=brust;";
                engEvalString(matlab,ss.str().c_str());
            };
            {
                std::stringstream ss;
                ss<<"frames{"<<o_count+1<<"}.tt=tt;";
                engEvalString(matlab,ss.str().c_str());
            };
            //engEvalString(matlab,"a=1");
        }
        //std::cout<<"step1\n";
        //fflush(stdout);
        std::stringstream ss;
        char s[20];
        //
        sprintf(s,"%.4i",o_count);
        ss<<"save('capture/frames_"<<s<<".mat','frames');";
        //ss<<"save('frames_"<<s<<".mat','frames');";
        engEvalString(matlab,ss.str().c_str());
        std::cout<<"ok\n";
        fflush(stdout);
        ++o_count;
        //if(o_count==30){
         //   o_count = 1;
        //engEvalString(matlab,"save('frames.mat','frames');");
        //};
        #endif
    };

    void timerEvent( QTimerEvent * event ) {
        int recali_time = 3; // recalibrate every 3 seconds
        int loop_rate = 30;
        ++count;

        cam.get_image();
		if(count==recali_time*loop_rate){
            imager->forceRecalibration();
            count = 0;
		};
        imager->process((unsigned char *)cam.buffer.start);

        //memcpy(buff,cam.buffer.start,cam.width*cam.height*2);

/*
        uvc.GetFrame(buff);
        imager->process(buff);
        uvc.ReleaseFrame();
*/
        const char * psym = "-\\|/";
        std::cout<<"\b"<<psym[count % 4];
        fflush(stdout);
    };

   bool notify(QObject * receiver, QEvent * ev) {
        if(ev->type() == QEvent::MouseButtonPress) {
            QMouseEvent * e = static_cast<QMouseEvent *>(ev);
            if(e->button()==Qt::LeftButton){
                //printf("mouse press Left\n");
                save_images();
                return true;
            };
        };
        if(ev->type() == QEvent::KeyPress) {
            QKeyEvent * e = static_cast<QKeyEvent *>(ev);
            if(e->key() == Qt::Key_Return) {
                save_images();
                return true;
            } else if(e->key() == Qt::Key_Tab) {
                //++view.vmode;
                return true;
            } else if(e->key() == Qt::Key_Escape) {
                exit(0);
                return true;
            };
        };
        return QApplication::notify(receiver,ev);
    };

    void cbOnFrame(unsigned short* image, unsigned int w, unsigned int h) {
        //imager_v.resize(w*h);
        //memcpy(&imager_v[0],image,w*h*sizeof(unsigned short));
        //frame_processed = true;
//   };

//   void timerEvent ( QTimerEvent * event ) {
        //cam.get_image();
        //std::cout<<".";
        //return;
        //TFlagState fl = imager.GetFlag();
        //if(fl!=fsFlagOpen && fl!=fsFlagClose){//the flag is moving, do not grab image
        //    return;
        //};
        /*
               frame_processed = false;
               //
               while(!frame_processed){
                   cam.get_image();
                   imager->process((unsigned char *)cam.buffer.start);
                   int k=0;
                   while(++k<5 && !frame_processed){
                       usleep(100);
                   };
               };
        */
        //
        //
        //fprintf();
        //std::cout<<fl<<" ";
        fflush(stdout);
        /*
        if(++count>50){
            imager.reinit();
            count = 0;
            //return;
        };
        */
        //usleep(10000);
        //for(int k=0;k<5;++k){
        //cam.get_image();
        //};
        //imager.filter_image(cam.buffer.start);
        //if(imager.get_flag()!=0)return;
        float * vals = new float[Width*Height];

        unsigned short * pV = image;
        //unsigned short * pCam = (unsigned short *)cam.buffer.start;
        for(int i = 0; i < (Width) * (Height); ++i) {
            vals[i] = ((float)(pV[i])-1000.0)*0.1;
            //vals[i] = pCam[i];
        };
        //memcpy(imager.out_buffer,cam.buffer.start,cam.width*cam.height*2);
        //
        // display image
        QRgb * pimg = (QRgb*)img.bits();
        //uchar * pbuf = (uchar*)(imager.out_buffer);
        //uchar * pc = (uchar*)(cam.buffer.start);
        float max=-1e6;
        float min=+1e6;
        float * vals1 = new float[Width*Height];

        //median filter
        std::vector<float> a;
        a.resize(9);
        memset(vals1,0,Width*Height*sizeof(float));
        for(int i=1; i<Height-1; ++i) {
            for(int j=1; j<Width-1; ++j) {
                /*
                int l =0;
                a.clear();
                for(int i1=-1;i1=0;i1+=2){
                    for(int j1=-1;j1=0;j1+=2){
                        if(i+i1<0 | i+i1>=Height | j+j1<0 | j+j1>=Width)continue;
                        a.push_back()
                    };
                };
                */
                int ii = i*Width+j;
                a[0] = vals[ii];
                a[1] = vals[ii+1];
                a[2] = vals[ii-1];
                a[3] = vals[ii-Width];
                a[4] = vals[ii+Width];
                a[5] = vals[ii-1-Width];
                a[6] = vals[ii-1+Width];
                a[7] = vals[ii+1-Width];
                a[8] = vals[ii+1+Width];
                std::nth_element(a.begin(),a.begin()+5,a.end());
                float pixel = a[5];
                vals1[ii] = pixel;
                //vals1[ii] = vals[ii];
                if(pixel > max)max = pixel;
                if(pixel < min)min = pixel;
            };
        };
        //int * vals = new int[Width * (Height-1)];
        /*
        		for(int i = 0; i < (Width) * (Height-1); ++i){
        		    //vals[i] = pc[2*i+1] << 8 | pc[2*i];
        		    //if(vals[i]<4000){
        		    	//vals[i] = vals[i+1];//pc[2*(i+1)+1] << 8 | pc[2*(i+1)];
        		    //};
        		};
        */

        /*
        		for(int i = 0; i < (Width) * (Height-1); ++i){
        		    int pixel = vals1[i];
        			if(pixel > max)max = pixel;
        			if(pixel < min)min = pixel;
        		};
        */

        //min = 1900;
        //max = 8000;
        //min = 1200;
        //max = 2000;
        //printf("\n[ %i %i]",min,max);

        for(int i = 0; i < (Width) * (Height); ++i) {
            float pixel = vals1[i];
            int a = std::min(239,std::max(0,int((pixel-min)*240/(max-min+1))));
            pimg[i] = qRgb(Iron[a][0],Iron[a][1],Iron[a][2]);
        };
//		// tell the painter to draw on the QImage
//		QPainter painter(&img); // sorry i forgot the "&"
//		painter.setPen(Qt::black);
//		painter.setFont(QFont("Arial", 10));
        // you probably want the to draw the text to the rect of the image
//		painter.drawText(img.rect(), Qt::AlignCenter, "Text on Image");
//		sstream ss;
        char * s[1024];
        temp_measure m;
        m.chip = 0;//imager->_tempChipLast;
        m.box = 0;//imager->_tempBoxLast;
        m.flag = 0;//imager->_tempFlagLast;
        m.chip1 = 0;
        QPainter painter(&img);
        painter.setPen(QPen(Qt::white, 1));
        for(int i=0; i<4; ++i) {
            painter.drawLine(Width/8+Width/4*i,Height/8,Width/8+Width/4*i,Height*7/8);
            painter.drawLine(Width/8,Height/8+Height/4*i,Width*7/8,Height/8+Height/4*i);
        };
        for(int i=0; i<3; ++i) {
            for(int j=0; j<3; ++j) {
                float temp = 0;
                int n = 0;
                for(int i1 = -Height/8; i1<Height/8; ++i1) {
                    for(int j1 = -Width/8; j1<Width/8; ++j1) {
                        int jj = Width/4*(j+1)+j1;
                        int ii = (Height/4)*(i+1)+i1;
                        temp+= vals1[jj+ii*Width];
                        ++n;
                    };
                };
                temp/=n;
                if(i==1 && j==1)m.energy = temp;
                m.ee[i*3+j] = temp;
                sprintf((char*)s,"%3.1f",temp);
                ll[i][j]->setText(QString("<font color='white' size='8'>")+(char*)s+QString("</font>"));
                ll[i][j]->adjustSize();
            };
        };
        label.setPixmap(QPixmap::fromImage(img));
        //
        //sprintf((char*)s,"temperature chip: %3.1f, flag: %3.1f, box: %3.1f",imager.TempChip,imager.TempFlag, imager.TempBox);
        info->setText(QString("<font color='black' size='6'>")+(char*)s+QString("</font>"));
        info->adjustSize();
        //delete vals;
        delete vals1;
        delete vals;
        hist.push_back(m);

        //std::ofstream ff("log.txt");
        //for(int i=0;i<hist.size();++i){
        //log1<<hist[i].energy<<" "<<hist[i].chip<<" "<<hist[i].box<<" "<<hist[i].flag<<" "<< hist[i].chip1<<"\n";
        //};
        //ff.flush();
        log1<<m.energy<<" "<<m.chip<<" "<<m.box<<" "<<m.flag<<" "<< m.chip1<<" ";
        for(int i=0; i<9; ++i)log1<<m.ee[i]<<" ";
        //log1<<double(imager.Timestamp)/10000000.0<<"\n";
        log1.flush();
    };
};


myApp * the_app;

void cbOnFrame(unsigned short* image, unsigned int w, unsigned int h) {
    the_app->cbOnFrame(image,w,h);
};


int main (int argc, char *argv[]) {
    pOnFrame = cbOnFrame;
    myApp a(argc, argv);
    the_app = &a;
    return a.exec();
}

